﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI;
using System.ComponentModel;
using System.Security.Permissions;
using System.Collections;

namespace TestComboLabel {
	[AspNetHostingPermission(SecurityAction.Demand, Level = AspNetHostingPermissionLevel.Minimal)]
	[AspNetHostingPermission(SecurityAction.InheritanceDemand, Level = AspNetHostingPermissionLevel.Minimal)]
	public class ComboLabel : DataBoundControl {
		private string m_strCurText = "";
		public string DataTextField {
			get {
				object o = ViewState["DataTextField"];
				return ((o == null) ? string.Empty : (string)o);
			}
			set {
				ViewState["DataTextField"] = value;
				if (Initialized) {
					OnDataPropertyChanged();
				}
			}
		}
		public string DataValueField {
			get {
				object o = ViewState["DataValueField"];
				return ((o == null) ? string.Empty : (string)o);
			}
			set {
				ViewState["DataValueField"] = value;
				if (Initialized) {
					OnDataPropertyChanged();
				}
			}
		}
		public string SelectedValue {
			get {
				object o = ViewState["SelectedValue"];
				return ((o == null) ? string.Empty : (string)o);
			}
			set {
				ViewState["SelectedValue"] = value;
				if (Initialized) {
					OnDataPropertyChanged();
				}
			}
		}

		protected override void PerformSelect() {
			if (!IsBoundUsingDataSourceID) {
				OnDataBinding(EventArgs.Empty);
			}
			GetData().Select(CreateDataSourceSelectArguments(),
				OnDataSourceViewSelectCallback);

			RequiresDataBinding = false;
			MarkAsDataBound();

			OnDataBound(EventArgs.Empty);
		}
		private void OnDataSourceViewSelectCallback(IEnumerable retrievedData) {
			if (IsBoundUsingDataSourceID) {
				OnDataBinding(EventArgs.Empty);
			}
			PerformDataBinding(retrievedData);
		}
		protected override void PerformDataBinding(IEnumerable retrievedData) {
			base.PerformDataBinding(retrievedData);
			if (retrievedData != null) {
				if (SelectedValue.Length == 0) {
					m_strCurText = "";
					return;
				}
				foreach (object dI in retrievedData) {
					string strTmpText = "";
					string strDataValue = "";

					if (DataValueField.Length > 0) {
						strDataValue = DataBinder.GetPropertyValue(dI, DataValueField, null);
					}
					else {
						PropertyDescriptorCollection props = TypeDescriptor.GetProperties(dI);
						if (props.Count >= 1) {
							if (null != props[0].GetValue(dI)) {
								strDataValue = props[0].GetValue(dI).ToString();
							}
						}
					}
					if (strDataValue == SelectedValue) {	//we found it!!
						if (DataTextField.Length > 0) {
							strTmpText = DataBinder.GetPropertyValue(dI, DataTextField, null);
						}
						else {
							PropertyDescriptorCollection props = TypeDescriptor.GetProperties(dI);
							if (props.Count >= 1) {
								if (null != props[0].GetValue(dI)) {
									strTmpText = props[0].GetValue(dI).ToString();
								}
							}
						}
						m_strCurText = strTmpText;
						return;
					}
				}
			}
		}
		protected override void Render(HtmlTextWriter writer) {

			// Render nothing if the control is empty.            
			if (m_strCurText.Length == 0) {
				return;
			}

			// Make sure the control is declared in a form tag 
			// with runat=server.
			if (Page != null) {
				Page.VerifyRenderingInServerForm(this);
			}
			Label lblOut = new Label();
			lblOut.Text = m_strCurText;
			lblOut.RenderControl(writer);
		}
	}
}
